[Libguestfs] [PATCH 2/2] customize: Add a slow test that firstboot works on a variety of real guests.

Richard W.M. Jones rjones at redhat.com
Fri Aug 26 17:33:47 UTC 2016


---
 .gitignore                  |   1 +
 customize/Makefile.am       |  41 ++++++++++++++-
 customize/test-firstboot.sh | 119 ++++++++++++++++++++++++++++++++++++++++++++
 3 files changed, 160 insertions(+), 1 deletion(-)
 create mode 100755 customize/test-firstboot.sh

diff --git a/.gitignore b/.gitignore
index a97fe11..0d98fcd 100644
--- a/.gitignore
+++ b/.gitignore
@@ -128,6 +128,7 @@ Makefile.in
 /customize/customize-options.pod
 /customize/customize-synopsis.pod
 /customize/stamp-virt-customize.pod
+/customize/test-firstboot-*.sh
 /customize/virt-customize
 /customize/virt-customize.1
 /daemon/actions.h
diff --git a/customize/Makefile.am b/customize/Makefile.am
index a76b6c5..3a3e229 100644
--- a/customize/Makefile.am
+++ b/customize/Makefile.am
@@ -21,6 +21,7 @@ EXTRA_DIST = \
 	$(generator_built) \
 	$(SOURCES_MLI) $(SOURCES_ML) $(SOURCES_C) \
 	customize_main.ml \
+	test-firstboot.sh \
 	test-virt-customize.sh \
 	test-virt-customize-docs.sh \
 	virt-customize.pod
@@ -192,12 +193,50 @@ TESTS = \
 
 if ENABLE_APPLIANCE
 TESTS += \
-	test-virt-customize.sh
+	test-virt-customize.sh \
+	$(SLOW_TESTS)
 endif
 
 check-valgrind:
 	$(MAKE) VG="$(top_builddir)/run @VG@" check
 
+# Slow tests of firstboot functionality in real guests.
+
+SLOW_TESTS = \
+	$(firstboot_test_scripts)
+
+check-slow:
+	$(MAKE) check TESTS="$(SLOW_TESTS)" SLOW=1
+
+firstboot_test_scripts := \
+	test-firstboot-rhel-4.9.sh \
+	test-firstboot-rhel-5.11.sh \
+	test-firstboot-rhel-6.8.sh \
+	test-firstboot-rhel-7.2.sh \
+	test-firstboot-debian-7.sh \
+	test-firstboot-debian-8.sh \
+	test-firstboot-fedora-24.sh \
+	test-firstboot-ubuntu-10.04.sh \
+	test-firstboot-ubuntu-12.04.sh \
+	test-firstboot-ubuntu-14.04.sh \
+	test-firstboot-ubuntu-16.04.sh
+# Firstboot is known-broken on RHEL 3:
+#	test-firstboot-rhel-3.9.sh
+# Debian 6 does not work, but should do.  The guest doesn't appear to
+# boot, so it may be a problem with the test-firstboot.sh test script.
+#	test-firstboot-debian-6.sh
+
+test-firstboot-%.sh:
+	rm -f $@ $@-t
+	f=`echo "$@" | sed 's/test-firstboot-\(.*\).sh/\1/'`; \
+	echo 'exec $$srcdir/test-firstboot.sh' "$$f" > $@-t
+	chmod 0755 $@-t
+	mv $@-t $@
+
+CLEANFILES += \
+	$(firstboot_test_scripts) \
+	firstboot-*.img
+
 # Dependencies.
 depend: .depend
 
diff --git a/customize/test-firstboot.sh b/customize/test-firstboot.sh
new file mode 100755
index 0000000..168b4f3
--- /dev/null
+++ b/customize/test-firstboot.sh
@@ -0,0 +1,119 @@
+#!/bin/bash -
+# Test firstboot functionality.
+# Copyright (C) 2016 Red Hat Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+
+# This slow test checks that firstboot works.
+#
+# NB. 'test-firstboot.sh' runs the tests, but the various tests are
+# run via the 'test-firstboot-GUESTNAME.sh' wrappers.
+
+export LANG=C
+set -e
+
+if [ -z "$SLOW" ]; then
+    echo "$0: use 'make check-slow' to run this test"
+    exit 77
+fi
+
+if [ -n "$SKIP_TEST_FIRSTBOOT_SH" ]; then
+    echo "$0: test skipped because environment variable is set."
+    exit 77
+fi
+
+guestname="$1"
+if [ -z "$guestname" ]; then
+    echo "$0: guestname parameter not set, don't run this test directly."
+    exit 1
+fi
+
+disk="firstboot-$guestname.img"
+rm -f "$disk"
+
+# If the guest doesn't exist in virt-builder, skip.  This is because
+# we test some RHEL guests which most users won't have access to.
+if ! virt-builder -l "$guestname" >/dev/null 2>&1; then
+    echo "$0: test skipped because \"$guestname\" not known to virt-builder."
+    exit 77
+fi
+
+# We can only run the tests on x86_64.
+if [ "$(uname -m)" != "x86_64" ]; then
+    echo "$0: test skipped because !x86_64."
+    exit 77
+fi
+
+# Check qemu is installed.
+qemu=qemu-system-x86_64
+if ! $qemu -help >/dev/null 2>&1; then
+    echo "$0: test skipped because $qemu not found."
+    exit 77
+fi
+
+# Some guests need special virt-builder parameters.
+# See virt-builder --notes "$guestname"
+declare -a extra
+case "$guestname" in
+    debian-6|debian-7)
+        extra[${#extra[*]}]='--edit'
+        extra[${#extra[*]}]='/etc/inittab:
+                                s,^#([1-9].*respawn.*/sbin/getty.*),$1,'
+        ;;
+    fedora*|rhel*|centos*)
+        extra[${#extra[*]}]='--selinux-relabel'
+        ;;
+    *)
+        ;;
+esac
+
+# Build a guest (using virt-builder) with some firstboot commands.
+#
+# The script currently assumes a Linux guest.  We should test Windows,
+# FreeBSD in future (XXX).
+virt-builder "$guestname" \
+             --quiet \
+             -o "$disk" \
+             --firstboot-command "mkdir /fb1; sleep 5" \
+             --firstboot-command "touch /fb1/fb2; sleep 5" \
+             --firstboot-command "poweroff" \
+             "${extra[@]}"
+
+# Boot the guest in qemu and wait for the firstboot scripts to run.
+#
+# Use IDE because some ancient guests don't support anything else.
+#
+# Adding a network device is not strictly necessary, but makes
+# the Debian 7 guest happier.
+timeout 300s \
+$qemu \
+    -nodefconfig \
+    -display none \
+    -machine accel=kvm:tcg \
+    -m 2048 \
+    -boot c \
+    -drive file="$disk",format=raw,if=ide \
+    -netdev user,id=usernet \
+    -device rtl8139,netdev=usernet \
+    -serial stdio ||:
+
+# Did the firstboot scripts run?  And in the right order?  We can tell
+# because the directory and file are created and so the 'stat'
+# commands should not fail in guestfish.
+guestfish --ro -a "$disk" -i \
+    statns /fb1 : \
+    statns /fb1/fb2
+
+rm "$disk"
-- 
2.7.4




More information about the Libguestfs mailing list